CADxp: While - CADxp

Aller au contenu

Page 1 sur 1
  • Vous ne pouvez pas commencer un sujet
  • Vous ne pouvez pas répondre à ce sujet

While

#1 L'utilisateur est hors-ligne   dfbiagio 

  • ceinture noire
  • Groupe : Membres
  • Messages : 460
  • Inscrit(e) : 28-juillet 03
  • LocationBinche

Posté 30 janvier 2019 - 19:41

Bonsoir à tous,
J'ai élaboré un petit lisp qui me permet d'incliner des textes suivant 2 points qlq.
Tout fonctionne correctement sauf quand je dois sortir, il marque une erreur que je ne comprends pas.
Voici ce lisp:

(defun c:test()
  (setq p1 (getpoint "\nPoint 1: ")
  	    p2 (getpoint "\nPoint 2: ")
 )
 (setq diff (mapcar '- p2 p1)
   	   ang (atan (/ (cadr diff)(car diff)))
 )
 (setq text (entget (car (entsel "Choix du texte: "))))
 (while text
  (if (/= text nil)(entmod (subst (cons 50 ang)(assoc 50 text) text)))
  (setq text (entget (car (entsel "Choix du texte: "))))
 )
)


Merci d'avance pour votre aide.
Bonne soirée.

Ce message a été modifié par didier - 31 janvier 2019 - 11:40 .
Raison de l'édition : ajout des bbcodes <code>

0

#2 L'utilisateur est hors-ligne   (gile) 

  • ceinture rouge et blanche 8em dan
  • Groupe : Moderateurs
  • Messages : 11291
  • Inscrit(e) : 02-septembre 05

Posté 30 janvier 2019 - 20:00

Salut,

while boucle tant que la condition (ici la variable text) n'est pas nil.
Donc, (if (/= text nil) sera toujours vrai (l'expression est donc inutile) et text ne sera jamais nil mais une erreur sera générée si (car (entsel "Choix du texte: ")) renvoie nil (si l'utilisateur ne sélectionne pas de texte), parce que (entget nil) génère une erreur.

Autrement dit (car (entsel ...)) peut renvoyer nil mais pas (entget ...). C'est donc sur le résultat de (car (entsel ...)) qu'il faut boucler.

(defun c:test (/ p1 p2 diff ang text elst)
  (setq p1 (getpoint "\nPoint 1: ")
        p2 (getpoint "\nPoint 2: ")
  )
  (setq diff (mapcar '- p2 p1)
        ang  (atan (/ (cadr diff) (car diff)))
  )
  (while (setq text (car (entsel "Choix du texte: ")))
    (setq elst (entget text))
    (entmod (subst (cons 50 ang) (assoc 50 elst) elst))
  )
  (princ)
)

Gilles Chanteau - gileCAD -
Développements sur mesure pour AutoCAD
Image IPB
0

#3 L'utilisateur est hors-ligne   dfbiagio 

  • ceinture noire
  • Groupe : Membres
  • Messages : 460
  • Inscrit(e) : 28-juillet 03
  • LocationBinche

Posté 31 janvier 2019 - 08:03

Un tout grand merci
.
Bonne journée.
0

#4 L'utilisateur est hors-ligne   eklundh80 

  • ceinture orange
  • Groupe : Membres
  • Messages : 20
  • Inscrit(e) : 22-février 18

Posté 31 janvier 2019 - 09:42

Salut
Pour sélectionner le texte ne vaudrait-il pas mieux filtrer la sélection:
(while (setq text (ssget '((0 . "*TEXT"))))
(setq elst (entget (car (ssname text 0))))

?
0

Partager ce sujet :


Page 1 sur 1
  • Vous ne pouvez pas commencer un sujet
  • Vous ne pouvez pas répondre à ce sujet

2 utilisateur(s) en train de lire ce sujet
0 membre(s), 2 invité(s), 0 utilisateur(s) anonyme(s)